# Return the list of samba shares available.

SMB_CONF="/etc/samba/smb.conf"
SMBSHARE_PATTERN='^[[:space:]]*path[[:space:]]*=[[:space:]]*'

# Loop through samba shares
for sharepath in `grep -i $SMBSHARE_PATTERN $SMB_CONF | awk -F = '{ print $2 }' `
do
	echo $sharepath 
done

exit 0


