<?php
// defines BP, xml, action, cookie
require '../header.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

switch ($action) {

	case "list":
			$result = $BP->get_legacy_archive_schedule_info($dpuID);
			if ($result !== false) {
				$xml->push('root');
				$xml->element('Any', $result['any'] == true ? '1' : '0');
				$xml->element('D2D2D', $result['d2d2d'] == true ? '1' : '0');
				$xml->element('CEP', $result['cep'] == true ? '1' : '0');
				$xml->pop(); // root
			} else {
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;

	case "disable":
			// identify the type of schedules to disable, either 'd2d2d' or 'any';
			$scheduleType = isset($_GET['sched']) ? $_GET['sched'] : 'any';
			$BP->buildResult($xml, $BP->disable_legacy_archive_schedules($scheduleType, $dpuID));
			echo($xml->getXml());
			break;
}

$BP->destroyCookie();
?>