<?php
 
  // general library functions
//require $rootdir . 'bpl/library.php';

require 'library.php';


/* 
$xmltest = "<root> \
	<Name>SQL Server 2005</Name> \
	<Visible>1</Visible> \
	</root>";
 
$clientapps = xmlToClientApps($xmltest);

var_dump($clientapps);
*/

// Convert an XML document for the client/app show/hide selections into an array.
//
function xmlToClientApps($xml)
{
	$parser = xml_parser_create();
	xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
	xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
	xml_parse_into_struct($parser, $xml, $values, $tags);
	xml_parser_free($parser);

	$returnArray = array();
	$oneApp = array();

	$stack = array();
	$i = 0;
	foreach ($values as $val) {
		if ($val['type'] == "open") {
			if ($val['tag'] != "root") {
				$field = buildFieldName($val['tag']);
				array_push($stack, $field);
			}

		} else if ($val['type'] == "close") {
			if ($val['tag'] != "root") {
				array_pop($stack);
			}
		} else if ($val['type'] == "complete") {
			$field = buildFieldName($val['tag']);
			array_push($stack, $field);
			$bBoolean = isBoolean($val['tag']);
			setArrayValue($oneApp, $stack, $val['value'], $bBoolean);
			array_pop($stack);
			if ($val['tag'] == 'visible') {
				$returnArray[] = $oneApp;
				$oneApp = array();
			}
		}
	}

	return $returnArray;
	
}

function setArrayValue(&$array, $stack, $value, $bBoolean) {
	if ($stack) {
		$key = array_shift($stack);
		setArrayValue($array[$key], $stack, $value, $bBoolean);
	} else {
		if ($bBoolean) {
			$array = $value == 'true' ? true : false;
		}else {
			$array = $value;
		}
	}
}

function buildFieldName($tag)
{
	$field = "";

	switch ($tag) {
			case "Name":
			$field = "name";
		
		case "Visible":
			$tag = "visible";
			break;
		}

	return $tag;
}

function isBoolean($tag)
{
	$bBoolean = false;
	switch ($tag) {
		case "visible":
			$bBoolean = true;
			break;
	}
	return $bBoolean;
}
?>
