<?php
// defines BP, xml, action, cookie
require 'header.php';

// set dpu ID
$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

// nvp type and name definitions
define("RRC", "RRC");
define("CONFIGURATION", "configuration");
define("EULA", "EULA");

$EULA_fileName = $rootdir . 'eula.html';

switch ($action) {
		
	case "list":
		$nvp = $BP->get_nvp_list(RRC, CONFIGURATION);
		if ($nvp !== false && count($nvp) > 0) {
			$EULA_Accepted = isset($nvp[EULA]) ? $nvp[EULA] : 'No';
			$xml->push('root');
			$xml->element(EULA, $EULA_Accepted);
			if (strtolower($EULA_Accepted) !== 'yes') {
				// list the available storage and disks in the LVM.
				$EULA_Contents = file_get_contents($EULA_fileName);
				if ($EULA_Contents === false) {
					$EULA_Contents = "License acceptance information not available.";
				}
				$xml->push('Contents');
				$xml->cData($EULA_Contents);
				$xml->pop('Contents');
			}
			$xml->pop('root');
		} else {
			$BP->buildResult($xml, false);
		}
		echo($xml->getXml());
		break;

	case "update":
		if (isset($_GET['eula'])) {
			$eula = $_GET['eula'];
			$eulaAcceptedArray = array(EULA => $eulaValue);
			$result = $BP->save_nvp_list(RRC, CONFIGURATION, $eulaAcceptedArray);
			$BP->buildREsult($xml, $result);
		} else {
			$BP->buildResult($xml, false, 'no license acceptance information was provided.');
		}
		echo($xml->getXml());
		break;

}


$BP->destroyCookie();
?>