<?php
// defines BP, xml, action, cookie
require 'header.php';

$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();

$vcenterInfo = array();
$bValid = true;

switch ($action) {

	case "list":	// list vcenter information.
			$result = $BP->get_vcenter_list($dpuID);
			if ($result !== false) {
				$xml->push("root");
				foreach ($result as $id => $name) {
					$xml->push('VCenter', array("ID" => $id, "Name" => $name));
					$info = $BP->get_vcenter_info($id, $dpuID);
					if ($info !== false) {
						if (isset($info['address'])) {
							$xml->element('Address', $info['address']);
						}
						if (isset($info['ip'])) {
							$xml->element('IP', $info['ip']);
						}
						if (isset($info['username'])) {
							$xml->element('Username', $info['username']);
						}
					}
					$xml->pop(); // VCenter
				}
				$xml->pop();
			} else {
				$BP->buildResult($xml, false);
			}				
			echo($xml->getXml());			
			break;
			
	case "info":	// list vcenter information.
			$id = isset($_GET['id']) ? $_GET['id'] : -1;
			$info = $BP->get_vcenter_info($id, $dpuID);
			if ($info !== false) {
				$id = $info['id'];
				$name = $info['name'];
				$xml->push('VCenter', array("ID" => $id, "Name" => $name));
				if (isset($info['address'])) {
					$xml->element('Address', $info['address']);
				}
				if (isset($info['username'])) {
					$xml->element('Username', $info['username']);
				}
				$xml->pop(); // VCenter
			} else {
				$BP->buildResult($xml, false);
			}				
			echo($xml->getXml());			
			break;
			
	case "update":
			// if updating, specify id
			if (isset($_GET['id'])) {
				$id = $_GET['id'];
				$vcenterInfo['id'] = $id;
			} else {
				$BP->buildResult($xml, false, "error: when updating vcenter information, an id must be specified.");
				$bValid = false;
			}
			// fall through to add.
	
	case "add":
			if ($bValid) {
				// Get the user definition from arguments.
				if (isset($_GET['name'])) {
					$vcenterInfo['address'] = $_GET['name'];
				}
				if (isset($_GET['username'])) {
					$vcenterInfo['login'] = $_GET['username'];
				}
				if (isset($_REQUEST['password'])) {
					$password = urldecode($_REQUEST['password']);
					$vcenterInfo['password'] = $password;
				}
				$BP->buildResult($xml, $BP->save_vcenter_info($vcenterInfo, $dpuID));
			}
			echo($xml->getXml());
			break;
					
	case "delete":
			$id = isset($_GET['id']) ? $_GET['id'] : -1;
			$BP->buildResult($xml, $BP->delete_vcenter_info($id, $dpuID));
			echo($xml->getXml());
			break;

}

$BP->destroyCookie();
?>