#!/bin/sh
#
# KAS 7/6/2015
# This script will look for an active support tunnel. If found then the port number is written to stdout.
# If no active tunnel is found, then 0 is written to stdout.
#

ps -leaf | grep ssh | grep dpu_client | grep -v grep > /dev/null 2>&1
if [[ $? == 0 ]]; then 
# Found active tunnel.
	PORT=`ps -leaf | grep ssh | grep dpu_client | grep -v grep | sed "s/.*-n -R //" | cut -f1 -d':'`
	echo -n $PORT
else 
# No active tunnel.
	echo -n 0
fi
exit 0
