<?php

// This file contains CSS to support the generation of email reports
// It is included in report_dpu.php and report_vault.php using a "require" statement.
// In order for this file to be interpreted as code to be executed, it
// must start and end with PHP start/end tags.

function getClientStyle() {
	return "font-size: 14px; text-align: right;";
}
function getSystemStyle() {
	return "font-size: 14px; font-weight: bold;";
}
function getCustomerStyle() {
	return "font-size: 14px; font-weight: bold;";
}
function getLocationStyle() {
	return "font-size: 14px;";
}
function getAppClientStyle() {
	return "font-size: 16px; text-align: right; font-weight: bold;";
}
function getLegendStyle() {
	return "font-size: 16px; text-align: right; font-weight: bold; vertical-align: middle;";
}
// used for every other row in Alerts and as a row in backups tables to indicate that no backups occurred
function getOffRowColor() {
	return "#F6F6F6";
}
// used to enhance current day in backups tables
function getCurrentDayColor() {
	return "#EAEAEA";
}

?>