<?php

/* If this script has PHP errors, bail out */
error_reporting(-1);
ini_set("display_errors", 1);
ini_set("html_errors", 0);

libxml_use_internal_errors(true);
$str = file_get_contents('php://input');
if (isset($str)) {
	$xml = simplexml_load_string($str);
	if (!$xml) {
		echo "Failed: ill-formed XML.\n";
		libxml_clear_errors();
		exit(1);
	}
	else {
		$ret = process_request($str);
		if ($ret === false) {
			$msg = bp_error();
			echo "$msg";
			exit(1);
		}
		else {
			echo "Success: $ret";
			exit(0);
		}
	}
}
else {
	echo "Error: Invalid request.";
	exit(1);
}

?>

