<?php
// defines BP, xml, action, cookie
require 'header.php';
// set of functions for user management
require 'userfunctions.php';

// set of functions used at initial login, including building a customer list.
require 'startupfunctions.php';

$customerInfoID = NULL;

switch ($action) {
	case "list":	buildCustomerList($BP, $xml, true);
					echo($xml->getXml());
					break;
					
	case "update":	// if updating, specify id
					if (isset($_GET['id'])) {
						$id = (int)$_GET['id'];
						$customerInfoID = array("id" => $id);
					}
					// fall through to add.
	
	case "add":		$customerInfo = array();
					if (isset($_GET['name'])) {
						$name = $_GET['name'];
						$customerInfo = array ("name" => $name);
					}
					
					// If an ID was specified for update, add it.
					if ($customerInfoID != NULL) {
						$customerInfo = array_merge($customerInfoID, $customerInfo);
					}
										
					if (isset($_GET['name']) || isset($_GET['id'])) {
						$BP->buildResult($xml, $BP->save_customer_info($customerInfo));
						echo($xml->getXml());
					} else {
						$BP->buildResult($xml, false, "error: customers.php: improper argument format; customer name or id must be specified.");
						echo($xml->getXml());
					}
					break;
					
	case "delete":	if (isset($_GET['id'])) {
						$customerID = (int)$_GET['id'];
					} else {
						// user specified name, translate to ID.
						$customerName = $_GET['name'];
						$customerID = getCustomerIDfromName($BP, $customerName);
					}
					if ($customerID != -1) {
						$BP->buildResult($xml, $BP->remove_customer($customerID));
						echo($xml->getXml());
					} else {
						$stringError = sprintf("error: customers.php: could not determine customer id from name %s.", $customerName);
						$BP->buildResult($xml, false, $stringError);
						echo($xml->getXml());
					}
					break;
}

$BP->destroyCookie();
?>
