<?php
// defines BP, xml, action, cookie
require 'header.php';

// initialize mail array.
$mailInfo = array();

switch ($action) {				
	case "list":	
	global $Log;
	$Log->writeVariable("in list");
			$bValid = true;
			
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
					$mailInfo = $BP->get_mail_info();
			} else {
				$mailInfo = $BP->get_mail_info($dpuID);
			}
			if ($mailInfo === false) {
				$bValid = false;
			} else {
				$useHTML = $BP->get_ini_value('Unattended Backup Information', 'NotificationsUseHtml', $dpuID);
				$sendPDF = $BP->get_ini_value('Unattended Backup Information', 'NotificationsSendPDF', $dpuID);
				
				$xml->push('root');
				$xml->push("Mail");	
				if (array_key_exists('authinfo', $mailInfo)) $xml->element("AuthInfo", $mailInfo['authinfo'] == true ? "1" : "0");
				if (array_key_exists('user', $mailInfo)) $xml->element("User", $mailInfo['user']);
				if (array_key_exists('password', $mailInfo)) $xml->element("Password", $mailInfo['password']);
				if (array_key_exists('smtp', $mailInfo)) $xml->element("SMTP", $mailInfo['smtp']);
				if (array_key_exists('system', $mailInfo)) $xml->element("System", $mailInfo['system']);
				if (array_key_exists('bp', $mailInfo)) $xml->element("BP", $mailInfo['bp']);
				if (array_key_exists('weekly', $mailInfo)) $xml->element("Weekly", $mailInfo['weekly']);
				if (array_key_exists('failure', $mailInfo)) $xml->element("Failure", $mailInfo['failure']);
				if (array_key_exists('schedule', $mailInfo)) $xml->element("Schedule", $mailInfo['schedule']);
				if (array_key_exists('disk', $mailInfo)) $xml->element("Disk", $mailInfo['disk']);	
				$xml->element('UseHTML', ($useHTML != false && (strtolower($useHTML) == 'no')) ? 0 : 1);
				$xml->element('SendPDF', ($sendPDF == false || (strtolower($sendPDF) == 'no')) ? 0 : 1);
				$xml->pop(); // Mail
				$xml->pop(); // root
			}		
			if (!$bValid) {
				$xml->clear(false);
				$BP->buildResult($xml, false);
			}
			echo($xml->getXml());
			break;
										
	case "update":
			// update mail info
			$options = array ('user' => 'user',
							  'password' => 'password',
							  'smtp' => 'smtp',
							  'test_mail' => 'test',
							  'system' => 'system',
							  'bp' => 'bp',
							  'weekly' => 'weekly',
							  'failure' => 'failure',
							  'schedule' => 'schedule',
							  'disk' => 'disk');
			
			$bOptions = array('authinfo' => 'bauthinfo');		
			$mailInfo = buildOptions($mailInfo, $options, $bOptions);	
			
			if (isset($mailInfo['password'])) {
			  $mailInfo['password'] = urldecode($mailInfo['password']);
			}	
			
			$dpuID = isset($_GET['sid']) ? (int)$_GET['sid'] : $BP->get_local_system_id();
			if (!isset($_GET['sid']) || $dpuID == $BP->get_local_system_id()) {
				$BP->buildResult($xml, $BP->save_mail_info($mailInfo));
			} else {
				$BP->buildResult($xml, $BP->save_mail_info($mailInfo, $dpuID));
			}
			
			if (isset($_GET['busehtml'])) {
				$enhanced = (int)$_GET['busehtml'];
				$useHTML = $enhanced == 0 ? 'NO' : 'YES';
				$result = $BP->set_ini_value("Unattended Backup Information", 'NotificationsUseHtml', $useHTML, $dpuID);
				if ($result !== true) {
					break;
				}
			}
			
			if (isset($_GET['sendpdf'])) {
				$sendPDF = (int)$_GET['sendpdf'];
				$pdfIniValue = $sendPDF == 0 ? 'NO' : 'YES';
				$result = $BP->set_ini_value("Unattended Backup Information", 'NotificationsSendPDF', $pdfIniValue, $dpuID);			
				if ($result !== true) {
					break;
				}
			}
			
			echo($xml->getXml());			
			break;
}

$BP->destroyCookie();
?>
